Name:		glibc219
Version:	2.19
Release:	1%{?dist}
Summary:	Test install of glibc in separate directory

Group:		System Environment/Libraries
License:	LGPLv2+ and LGPLv2+ with exceptions and GPLv2+
URL:		http://www.gnu.org/software/glibc/
Source0:	http://ftp.gnu.org/gnu/libc/glibc-%{version}.tar.xz
Source1:	runwithglibc.c
BuildRequires:	gcc libcap-devel
Requires:	libcap
AutoReqProv:	0

%description
The glibc package contains standard libraries which are used by
multiple programs on the system. In order to save disk space and
memory, as well as to make upgrading easier, common system code is
kept in one place and shared between programs. This particular package
contains the most important sets of shared libraries: the standard C
library and the standard math library. Without these two libraries, a
Linux system will not function.

This package contains a test version of glibc 2.19 to try to provide
an alternate glibc for programs that require newer version.

%prep
%setup -q -n glibc-%{version}

%build
mkdir build
cd build
../configure --prefix=%{_libdir}-%{version}
make %{?_smp_mflags}
gcc -o runwith219 %{SOURCE1} -lcap

%install
cd build
make install DESTDIR=%{buildroot}
mkdir %{buildroot}%{_bindir}
install -m 711 runwith219 %{buildroot}%{_bindir}/runwith219

%files
%doc
%{_libdir}-%{version}
%caps(cap_sys_admin=ep) %attr(711,root,root) %{_bindir}/runwith219

%changelog
* Wed Oct 17 2018 Josko Plazonic <plazonic@princeton.edu>
- initial build
