// Written some time ago by Josko Plazonic <plazonic@princeton.edu>
// Modified on Oct 17th 2018 into a simple wrapper to start programs with new glibc
// gcc -o testmount testmount.c -lcap
// setcap cap_sys_admin+ep 
#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <sys/mount.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <sched.h>
#include <unistd.h>
#include <sys/capability.h>

int main(int argc, char *argv[])
{
        cap_t caps;
        struct stat sb;

        if(argc<2) {
                error(EXIT_FAILURE,0,"Please provide an executable to run.");
                exit(1);
        }

        caps = cap_get_proc();
        if (!caps) {
                error(EXIT_FAILURE,0,"Cannot get capabilities.");
                exit(1);
        }

        if(unshare(CLONE_NEWNS) < 0) {
                error(EXIT_FAILURE,0,"Failed to create mount namespace.");
                exit(1);
        }

        if(mount("none", "/", "", MS_REC | MS_SLAVE, NULL) < 0) {
                error(EXIT_FAILURE,0,"Failed to unshare mount namespace.");
                exit(1);
        }

        if(mount("/usr/lib64-2.19/lib/ld-2.19.so", "/lib64/ld-linux-x86-64.so.2", "", MS_BIND, NULL) < 0) {
                error(EXIT_FAILURE,0,"Failed to mount new ld.so");
                exit(1);
        }

        if (cap_clear(caps)) {
                error(EXIT_FAILURE,0,"Cannot clear capabilities.");
                exit(1);
        }
        if (cap_set_proc(caps)) {
                error(EXIT_FAILURE,0,"Failed to clear capabilities.");
                exit(1);
        }
        setenv("LD_LIBRARY_PATH","/usr/lib64-2.19/lib:/lib64:/usr/lib64",1);
        execvp(argv[1], argv + 1);
        error(EXIT_FAILURE, 0,"failed to execute %s", argv[optind]);

        return 1;
}
